commit 6eb8d15f64841cfbcc0a88110f7e7e3cb08cce6a
Author: Assos Assos <assos+forge@centrale-marseille.fr>
Date:   Wed May 21 22:41:42 2014 +0200

    Weekly update of contrib modules

diff --git a/drupal7/sites/all/modules/imce/imce.info b/drupal7/sites/all/modules/imce/imce.info
index e8699c8c..9fd852c5 100644
--- a/drupal7/sites/all/modules/imce/imce.info
+++ b/drupal7/sites/all/modules/imce/imce.info
@@ -4,9 +4,9 @@ core = "7.x"
 package = "Media"
 configure = "admin/config/media/imce"
 
-; Information added by Drupal.org packaging script on 2013-12-17
-version = "7.x-1.8"
+; Information added by Drupal.org packaging script on 2014-05-16
+version = "7.x-1.9"
 core = "7.x"
 project = "imce"
-datestamp = "1387302359"
+datestamp = "1400275428"
 
diff --git a/drupal7/sites/all/modules/imce/imce.install b/drupal7/sites/all/modules/imce/imce.install
index 688c6b5b..40ddcd3f 100644
--- a/drupal7/sites/all/modules/imce/imce.install
+++ b/drupal7/sites/all/modules/imce/imce.install
@@ -101,4 +101,24 @@ function imce_update_7001(&$sandbox) {
     db_drop_table('imce_files');
     return t('Migrated IMCE files.');
   }
+}
+
+/**
+ * Fixes misconfigurations where anonymous user is given User-1 profile
+ */
+function imce_update_7002() {
+  $roles = variable_get('imce_roles_profiles', array());
+  $rid = DRUPAL_ANONYMOUS_RID;
+  if (!empty($roles[$rid])) {
+    $update = FALSE;
+    foreach ($roles[$rid] as $key => $value) {
+      if ($value == 1 && substr($key, -4) == '_pid') {
+        $roles[$rid][$key] = '0';
+        $update = TRUE;
+      }
+    }
+    if ($update) {
+      variable_set('imce_roles_profiles', $roles);
+    }
+  }
 }
\ No newline at end of file
diff --git a/drupal7/sites/all/modules/imce/inc/imce.admin.inc b/drupal7/sites/all/modules/imce/inc/imce.admin.inc
index d88cd28d..c2d3625c 100644
--- a/drupal7/sites/all/modules/imce/inc/imce.admin.inc
+++ b/drupal7/sites/all/modules/imce/inc/imce.admin.inc
@@ -35,6 +35,18 @@ function imce_admin() {
     '#attributes' => array('id' => 'imce-profiles-list'),
   );
   $output['form'] = drupal_get_form('imce_admin_form');
+
+  // Display security warnings
+  if (empty($_POST)) {
+    $roles = variable_get('imce_roles_profiles', array());
+    if (!empty($roles[DRUPAL_ANONYMOUS_RID]['public_pid']) || !empty($roles[DRUPAL_ANONYMOUS_RID]['private_pid'])) {
+      drupal_set_message(t('Anonymous user role has access to IMCE.') . ' ' . t('Make sure this is not a misconfiguration.'), 'warning');
+    }
+    if (imce_admin_check_wildcard_upload(DRUPAL_AUTHENTICATED_RID, $roles)) {
+      drupal_set_message(t('Authenticated user role is assigned a configuration profile with unrestricted file extensions.') . ' ' . t('Make sure this is not a misconfiguration.'), 'warning');
+    }
+  }
+
   return $output;
 }
 
@@ -146,6 +158,17 @@ function imce_admin_theme($variables) {
   return $output;
 }
 
+/**
+ * Validate admin form.
+ */
+function imce_admin_form_validate($form, &$form_state) {
+  $roles = $form_state['values']['roles'];
+  // Check anonymous profile. Do not allow wildcard upload.
+  if ($key = imce_admin_check_wildcard_upload(DRUPAL_ANONYMOUS_RID, $roles)) {
+    form_error($form['roles'][DRUPAL_ANONYMOUS_RID][$key], t('Anonymous user role can not have a configuration profile with unrestricted file extensions.'));
+  }
+}
+
 /**
  * Submit admin form.
  */
@@ -173,7 +196,7 @@ function imce_profile_operations($op = 'add', $pid = 0) {
     return drupal_get_form('imce_profile_delete_form', $pid);
   }
   //add-edit
-  if ($pid != 1 || $GLOBALS['user']->uid == 1) {
+  if ($op === 'add' || $op === 'edit') {
     return drupal_get_form('imce_profile_form', $pid);
   }
   drupal_access_denied();
@@ -688,5 +711,30 @@ function imce_rolesort($r1, $r2) {
   return $r1['weight']-$r2['weight'];
 }
 
+/**
+ * Checks if the given role can upload all extensions.
+ */
+function imce_admin_check_wildcard_upload($rid, $conf = NULL) {
+  if (!isset($conf)) {
+    $conf = variable_get('imce_roles_profiles', array());
+  }
+  if (!empty($conf[$rid])) {
+    foreach ($conf[$rid] as $key => $pid) {
+      if ($pid && substr($key, -4) == '_pid') {
+        if ($profile = imce_load_profile($pid)) {
+          if ($profile['extensions'] === '*' && !empty($profile['directories'])) {
+            foreach ($profile['directories'] as $dirconf) {
+              if (!empty($dirconf['upload'])) {
+                return $key;
+              }
+            }
+          }
+        }
+      }
+    }
+  }
+  return FALSE;
+}
+
 //Include core profile functions.
 include_once DRUPAL_ROOT . '/' . drupal_get_path('module', 'imce') . '/inc/imce.core.profiles.inc';
\ No newline at end of file
diff --git a/drupal7/sites/all/modules/imce/inc/imce.page.inc b/drupal7/sites/all/modules/imce/inc/imce.page.inc
index bcb00b2d..ab52aa78 100644
--- a/drupal7/sites/all/modules/imce/inc/imce.page.inc
+++ b/drupal7/sites/all/modules/imce/inc/imce.page.inc
@@ -116,7 +116,7 @@ function imce_js($user, $scheme, $jsop = '') {
   //disable devel log.
   $GLOBALS['devel_shutdown'] = FALSE;
   //for upload we must return plain text header.
-  drupal_add_http_header('Content-Type', 'text/' . ($jsop == 'upload' ? 'html' : 'javascript') . '; charset=utf-8');
+  drupal_add_http_header('Content-Type', (!empty($_POST['html_response']) ? 'text/html' : 'application/json') . '; charset=utf-8');
   print drupal_json_encode($response);
   exit();
 }
@@ -144,6 +144,7 @@ function imce_upload_form($form, &$form_state, $ref) {
     '#submit' => $imce['perm']['upload'] ? array('imce_upload_submit') : NULL,
   );
   $form = array('fset_upload' => array('#type' => 'fieldset', '#title' => t('Upload file')) + $form);
+  $form['html_response'] = array('#type' => 'hidden', '#default_value' => '1');
   $form['#attributes']['enctype'] = 'multipart/form-data';
   $form['#action'] = $imce['url'];
   return $form;
diff --git a/drupal7/sites/all/modules/imce/js/imce.js b/drupal7/sites/all/modules/imce/js/imce.js
index 2e97b4aa..4e8948d0 100644
--- a/drupal7/sites/all/modules/imce/js/imce.js
+++ b/drupal7/sites/all/modules/imce/js/imce.js
@@ -7,8 +7,8 @@ hooks: {load: [], list: [], navigate: [], cache: []},
 //initiate imce.
 initiate: function() {
   imce.conf = Drupal.settings.imce || {};
-  imce.ie = (navigator.userAgent.match(/msie (\d+)/i) || ['', 0])[1] * 1;
   if (imce.conf.error != false) return;
+  imce.ie = (navigator.userAgent.match(/msie (\d+)/i) || ['', 0])[1] * 1;
   imce.FLW = imce.el('file-list-wrapper'), imce.SBW = imce.el('sub-browse-wrapper');
   imce.NW = imce.el('navigation-wrapper'), imce.BW = imce.el('browse-wrapper');
   imce.PW = imce.el('preview-wrapper'), imce.FW = imce.el('forms-wrapper');
@@ -19,6 +19,8 @@ initiate: function() {
   imce.initiateList();//process file list
   imce.initiateOps();//prepare operation tabs
   imce.refreshOps();
+  // Bind global error handler
+  $(document).ajaxError(imce.ajaxError);
   imce.invoke('load', window);//run functions set by external applications.
 },
 
@@ -241,12 +243,19 @@ setHtmlOps: function () {
 
 //convert upload form to an op.
 setUploadOp: function () {
-  var form = imce.el('imce-upload-form');
+  var el, form = imce.el('imce-upload-form');
   if (!form) return;
   $(form).ajaxForm(imce.uploadSettings()).find('fieldset').each(function() {//clean up fieldsets
     this.removeChild(this.firstChild);
     $(this).after(this.childNodes);
   }).remove();
+  // Set html response flag
+  el = form.elements['files[imce]'];
+  if (el && el.files && window.FormData) {
+    if (el = form.elements.html_response) {
+      el.value = 0;
+    }
+  } 
   imce.opAdd({name: 'upload', title: Drupal.t('Upload'), content: form});//add op
 },
 
@@ -257,7 +266,7 @@ setFileOps: function () {
   $(form.elements.filenames).parent().remove();
   $(form).find('fieldset').each(function() {//remove fieldsets
     var $sbmt = $('input:submit', this);
-    if (!$sbmt.size()) return;
+    if (!$sbmt.length) return;
     var Op = {name: $sbmt.attr('id').substr(5)};
     var func = function() {imce.fopSubmit(Op.name); return false;};
     $sbmt.click(func);
@@ -279,7 +288,7 @@ refreshOps: function() {
 //add a new file operation
 opAdd: function (op) {
   var oplist = imce.el('ops-list'), opcons = imce.el('op-contents');
-  var name = op.name || ('op-'+ $(oplist).children('li').size());
+  var name = op.name || ('op-'+ $(oplist).children('li').length);
   var title = op.title || 'Untitled';
   var Op = imce.ops[name] = {title: title};
   if (op.content) {
@@ -323,7 +332,7 @@ opClick: function(name) {
           var $inputs = $('input', imce.ops[imce.vars.op].div);
           $inputs.eq(0).focus();
           //form inputs become invisible in IE. Solution is as stupid as the behavior.
-          $('html').is('.ie') && $inputs.addClass('dummyie').removeClass('dummyie');
+          $('html').hasClass('ie') && $inputs.addClass('dummyie').removeClass('dummyie');
        }
       });
     });
@@ -439,7 +448,19 @@ uploadValidate: function (data, form, options) {
 
 //settings for upload
 uploadSettings: function () {
-  return {beforeSubmit: imce.uploadValidate, success: function (response) {imce.processResponse($.parseJSON(response));}, complete: function () {imce.fopLoading('upload', false);}, resetForm: true};
+  return {
+    beforeSubmit: imce.uploadValidate,
+    success: function (response) {
+      try{
+        imce.processResponse($.parseJSON(response));
+      } catch(e) {}
+    },
+    complete: function () {
+      imce.fopLoading('upload', false);
+    },
+    resetForm: true,
+    dataType: 'text'
+  };
 },
 
 //validate default ops(delete, thumb, resize)
@@ -449,7 +470,7 @@ fopValidate: function(fop) {
     case 'delete':
       return confirm(Drupal.t('Delete selected files?'));
     case 'thumb':
-      if (!$('input:checked', imce.ops['thumb'].div).size()) {
+      if (!$('input:checked', imce.ops['thumb'].div).length) {
         return imce.setMessage(Drupal.t('Please select a thumbnail.'), 'error');
       }
       return imce.validateImage();
@@ -486,7 +507,7 @@ commonSubmit: function(fop) {
 
 //settings for default file operations
 fopSettings: function (fop) {
-  return {url: imce.ajaxURL(fop), type: 'POST', dataType: 'json', success: imce.processResponse, complete: function (response) {imce.fopLoading(fop, false);}, data: imce.vars.opform +'&filenames='+ escape(imce.serialNames()) +'&jsop='+ fop + (imce.ops[fop].div ? '&'+ $('input, select, textarea', imce.ops[fop].div).serialize() : '')};
+  return {url: imce.ajaxURL(fop), type: 'POST', dataType: 'json', success: imce.processResponse, complete: function (response) {imce.fopLoading(fop, false);}, data: imce.vars.opform +'&filenames='+ encodeURIComponent(imce.serialNames()) +'&jsop='+ fop + (imce.ops[fop].div ? '&'+ $('input, select, textarea', imce.ops[fop].div).serialize() : '')};
 },
 
 //toggle loading state
@@ -536,7 +557,7 @@ prepareMsgs: function () {
     $('>div', msgs).each(function (){
       var type = this.className.split(' ')[1];
       var li = $('>ul li', this);
-      if (li.size()) li.each(function () {imce.setMessage(this.innerHTML, type);});
+      if (li.length) li.each(function () {imce.setMessage(this.innerHTML, type);});
       else imce.setMessage(this.innerHTML, type);
     });
     $(msgs).remove();
@@ -703,7 +724,10 @@ processRow: function (row) {
 
 //decode urls. uses unescape. can be overridden to use decodeURIComponent
 decode: function (str) {
-  return unescape(str);
+  try {
+    return decodeURIComponent(str);
+  } catch(e) {}
+  return str;
 },
 
 //decode and convert to plain text
@@ -771,7 +795,7 @@ updateUI: function() {
     return false;
   }).appendTo('#op-contents')[0];
   //navigation-header
-  if (!$('#navigation-header').size()) {
+  if (!$('#navigation-header').length) {
     $(imce.NW).children('.navigation-text').attr('id', 'navigation-header').wrapInner('<span></span>');
   }
   //log
@@ -801,6 +825,6 @@ updateUI: function() {
 };
 
 //initiate
-$(document).ready(imce.initiate).ajaxError(imce.ajaxError);
+$(document).ready(imce.initiate);
 
 })(jQuery);
\ No newline at end of file
diff --git a/drupal7/sites/all/modules/imce/js/imce_extras.js b/drupal7/sites/all/modules/imce/js/imce_extras.js
index f5cff029..b558cc50 100644
--- a/drupal7/sites/all/modules/imce/js/imce_extras.js
+++ b/drupal7/sites/all/modules/imce/js/imce_extras.js
@@ -180,7 +180,7 @@ imce.setResizer = function (resizer, axis, area1, area2, Min, callback) {
 //get&set area dimensions of the last session from the cookie
 imce.recallDimensions = function() {
   var $body = $(document.body);
-  if (!$body.is('.imce')) return;
+  if (!$body.hasClass('imce')) return;
   //row heights
   imce.recallHeights(imce.cookie('imcebwh') * 1);
   $(window).resize(function(){imce.recallHeights()});
@@ -214,9 +214,9 @@ imce.recallHeights = function(bwFixedHeight) {
 //cookie get & set
 imce.cookie = function (name, value) {
   if (typeof(value) == 'undefined') {//get
-    return unescape((document.cookie.match(new RegExp('(^|;) *'+ name +'=([^;]*)(;|$)')) || ['', '', ''])[2]);
+    return document.cookie ? imce.decode((document.cookie.match(new RegExp('(?:^|;) *' + name + '=([^;]*)(?:;|$)')) || ['', ''])[1].replace(/\+/g, '%20')) : '';
   }
-  document.cookie = name +'='+ escape(value) +'; expires='+ (new Date(new Date() * 1 + 15 * 86400000)).toGMTString() +'; path=' + Drupal.settings.basePath + 'imce';//set
+  document.cookie = name +'='+ encodeURIComponent(value) +'; expires='+ (new Date(new Date() * 1 + 15 * 86400000)).toUTCString() +'; path=' + Drupal.settings.basePath + 'imce';//set
 };
 
 //view thumbnails(smaller than tMaxW x tMaxH) inside the rows.
diff --git a/drupal7/sites/all/modules/imce/js/imce_set_app.js b/drupal7/sites/all/modules/imce/js/imce_set_app.js
index 23908688..419f7df6 100644
--- a/drupal7/sites/all/modules/imce/js/imce_set_app.js
+++ b/drupal7/sites/all/modules/imce/js/imce_set_app.js
@@ -53,7 +53,7 @@ imce.hooks.load.push(function(win) {
     if (appFields.url.indexOf(',') > -1) {
       var arr = appFields.url.split(',');
       for (var i in arr) {
-        if ($('#'+ arr[i], appWindow.document).size()) {
+        if ($('#'+ arr[i], appWindow.document).length) {
           appFields.url = arr[i];
           break;
         }
diff --git a/drupal7/sites/all/modules/imce/js/imce_set_inline.js b/drupal7/sites/all/modules/imce/js/imce_set_inline.js
index 82706b74..08891a10 100644
--- a/drupal7/sites/all/modules/imce/js/imce_set_inline.js
+++ b/drupal7/sites/all/modules/imce/js/imce_set_inline.js
@@ -21,7 +21,7 @@ Drupal.behaviors.imceInline = {attach: function(context, settings) {
 //function to be executed when imce loads.
 ii.load = function(win) {
   win.imce.setSendTo(Drupal.t('Insert file'), ii.insert);
-  $(window).unload(function() {
+  $(window).bind('unload', function() {
     if (ii.pop && !ii.pop.closed) ii.pop.close();
   });
 };
diff --git a/drupal7/sites/all/modules/views/handlers/views_handler_area_messages.inc b/drupal7/sites/all/modules/views/handlers/views_handler_area_messages.inc
new file mode 100644
index 00000000..eb1e22ae
--- /dev/null
+++ b/drupal7/sites/all/modules/views/handlers/views_handler_area_messages.inc
@@ -0,0 +1,34 @@
+<?php
+
+/**
+ * @file
+ * Contains views_handler_area_messages.
+ */
+
+/**
+ * Provides an area for messages.
+ */
+class views_handler_area_messages extends views_handler_area {
+
+  /**
+   * {@inheritdoc}
+   */
+  public function option_definition() {
+    $options = parent::option_definition();
+    // Set the default to TRUE so it shows on empty pages by default.
+    $options['empty']['default'] = TRUE;
+    return $options;
+  }
+
+  /**
+   * {@inheritdoc}
+   */
+  public function render($empty = FALSE) {
+    $return = '';
+    if (!$empty || !empty($this->options['empty'])) {
+      $return = theme('status_messages');
+    }
+    return $return;
+  }
+
+}
diff --git a/drupal7/sites/all/modules/views/handlers/views_handler_field_date.inc b/drupal7/sites/all/modules/views/handlers/views_handler_field_date.inc
index 8517f0b5..f2c63710 100644
--- a/drupal7/sites/all/modules/views/handlers/views_handler_field_date.inc
+++ b/drupal7/sites/all/modules/views/handlers/views_handler_field_date.inc
@@ -16,6 +16,8 @@ class views_handler_field_date extends views_handler_field {
 
     $options['date_format'] = array('default' => 'small');
     $options['custom_date_format'] = array('default' => '');
+    $options['second_date_format_custom'] = array('default' => '');
+    $options['second_date_format'] = array('default' => 'small');
     $options['timezone'] = array('default' => '');
 
     return $options;
@@ -36,6 +38,7 @@ class views_handler_field_date extends views_handler_field {
         'custom' => t('Custom'),
         'raw time ago' => t('Time ago'),
         'time ago' => t('Time ago (with "ago" appended)'),
+        'today time ago' => t('Time ago (with "ago" appended) for today\'s date, but not for other dates'),
         'raw time hence' => t('Time hence'),
         'time hence' => t('Time hence (with "hence" appended)'),
         'raw time span' => t('Time span (future dates have "-" prepended)'),
@@ -49,8 +52,39 @@ class views_handler_field_date extends views_handler_field {
       '#title' => t('Custom date format'),
       '#description' => t('If "Custom", see the <a href="@url" target="_blank">PHP manual</a> for date formats. Otherwise, enter the number of different time units to display, which defaults to 2.', array('@url' => 'http://php.net/manual/function.date.php')),
       '#default_value' => isset($this->options['custom_date_format']) ? $this->options['custom_date_format'] : '',
-      '#dependency' => array('edit-options-date-format' => array('custom', 'raw time ago', 'time ago', 'raw time hence', 'time hence', 'raw time span', 'time span', 'raw time span', 'inverse time span', 'time span')),
+      '#dependency' => array('edit-options-date-format' => array('custom', 'raw time ago', 'time ago', 'today time ago', 'raw time hence', 'time hence', 'raw time span', 'time span', 'raw time span', 'inverse time span', 'time span')),
     );
+    $form['second_date_format'] = array(
+     '#type' => 'select',
+     '#title' => t('Second date format'),
+     '#options' => $date_formats + array(
+       'custom' => t('Custom'),
+     ),
+     '#description' => t('The date format which will be used for rendering dates other than today.'),
+     '#default_value' => isset($this->options['second_date_format']) ? $this->options['second_date_format'] : 'small',
+     '#dependency' => array('edit-options-date-format' => array('today time ago')),
+   );
+   $form['second_date_format_custom'] = array(
+     '#type' => 'textfield',
+     '#title' => t('Custom date format of second date'),
+     '#description' => t('If "Custom" is selected in "Second date format", see the <a href="@url" target="_blank">PHP manual</a> for date formats. Otherwise, enter the number of different time units to display, which defaults to 2.', array('@url' => 'http://php.net/manual/function.date.php')),
+     '#default_value' => isset($this->options['second_date_format_custom']) ? $this->options['second_date_format_custom'] : '',
+     // We have to use states instead of ctools dependency because dependency
+     // doesn't handle multiple conditions.
+     '#states' => array(
+       'visible' => array(
+         '#edit-options-date-format' => array('value' => 'today time ago'),
+         '#edit-options-second-date-format' => array('value' => 'custom'),
+       ),
+     ),
+     // We have to use ctools dependency too because states doesn't add the
+     // correct left margin to the element's wrapper.
+     '#dependency' => array(
+       // This condition is handled by form API's states.
+//        'edit-options-date-format' => array('today time ago'),
+       'edit-options-second-date-format' => array('custom'),
+     ),
+   );
     $form['timezone'] = array(
       '#type' => 'select',
       '#title' => t('Timezone'),
@@ -66,7 +100,7 @@ class views_handler_field_date extends views_handler_field {
   function render($values) {
     $value = $this->get_value($values);
     $format = $this->options['date_format'];
-    if (in_array($format, array('custom', 'raw time ago', 'time ago', 'raw time hence', 'time hence', 'raw time span', 'time span', 'raw time span', 'inverse time span', 'time span'))) {
+    if (in_array($format, array('custom', 'raw time ago', 'time ago', 'today time ago', 'raw time hence', 'time hence', 'raw time span', 'time span', 'raw time span', 'inverse time span', 'time span'))) {
       $custom_format = $this->options['custom_date_format'];
     }
 
@@ -78,6 +112,21 @@ class views_handler_field_date extends views_handler_field {
           return format_interval($time_diff, is_numeric($custom_format) ? $custom_format : 2);
         case 'time ago':
           return t('%time ago', array('%time' => format_interval($time_diff, is_numeric($custom_format) ? $custom_format : 2)));
+        case 'today time ago':
+          $second_format = $this->options['second_date_format'];
+          $second_custom_format = $this->options['second_date_format_custom'];
+          if (format_date(REQUEST_TIME, 'custom', 'Y-m-d', $timezone) == format_date($value, 'custom', 'Y-m-d', $timezone)) {
+            return t('%time ago', array('%time' => format_interval($time_diff, is_numeric($custom_format) ? $custom_format : 2)));
+          }
+          elseif ($second_format == 'custom') {
+            if ($second_custom_format == 'r') {
+              return format_date($value, $second_format, $second_custom_format, $timezone, 'en');
+            }
+            return format_date($value, $second_format, $second_custom_format, $timezone);
+          }
+          else {
+            return format_date($value, $this->options['second_date_format'], '', $timezone);
+          }
         case 'raw time hence':
           return format_interval(-$time_diff, is_numeric($custom_format) ? $custom_format : 2);
         case 'time hence':
diff --git a/drupal7/sites/all/modules/views/handlers/views_handler_filter.inc b/drupal7/sites/all/modules/views/handlers/views_handler_filter.inc
index f5db70f9..8583605b 100644
--- a/drupal7/sites/all/modules/views/handlers/views_handler_filter.inc
+++ b/drupal7/sites/all/modules/views/handlers/views_handler_filter.inc
@@ -91,7 +91,11 @@ class views_handler_filter extends views_handler {
     }
 
     if ($this->multiple_exposed_input()) {
-      $this->group_info = array_filter($options['group_info']['default_group_multiple']);
+      $this->group_info = NULL;
+      if (!empty($options['group_info']['default_group_multiple'])) {
+        $this->group_info = array_filter($options['group_info']['default_group_multiple']);
+      }
+
       $this->options['expose']['multiple'] = TRUE;
     }
 
@@ -116,6 +120,7 @@ class views_handler_filter extends views_handler {
         'label' => array('default' => '', 'translatable' => TRUE),
         'description' => array('default' => '', 'translatable' => TRUE),
         'use_operator' => array('default' => FALSE, 'bool' => TRUE),
+        'operator_label' => array('default' => '', 'translatable' => TRUE),
         'operator' => array('default' => ''),
         'identifier' => array('default' => ''),
         'required' => array('default' => FALSE, 'bool' => TRUE),
@@ -510,6 +515,16 @@ class views_handler_filter extends views_handler {
         '#description' => t('Allow the user to choose the operator.'),
         '#default_value' => !empty($this->options['expose']['use_operator']),
       );
+      $form['expose']['operator_label'] = array(
+        '#type' => 'textfield',
+        '#default_value' => $this->options['expose']['operator_label'],
+        '#title' => t('Operator label'),
+        '#size' => 40,
+        '#description' => t('This will appear before your operator select field.'),
+        '#dependency' => array(
+          'edit-options-expose-use-operator' => array(1)
+        ),
+      );
       $form['expose']['operator_id'] = array(
         '#type' => 'textfield',
         '#default_value' => $this->options['expose']['operator_id'],
@@ -754,10 +769,8 @@ class views_handler_filter extends views_handler {
       $operator = $this->options['expose']['operator_id'];
       $this->operator_form($form, $form_state);
       $form[$operator] = $form['operator'];
-
-      if (isset($form[$operator]['#title'])) {
-        unset($form[$operator]['#title']);
-      }
+      $form[$operator]['#title'] =  $this->options['expose']['operator_label'];
+      $form[$operator]['#title_display'] = 'invisible';
 
       $this->exposed_translate($form[$operator], 'operator');
 
diff --git a/drupal7/sites/all/modules/views/handlers/views_handler_filter_boolean_operator_string.inc b/drupal7/sites/all/modules/views/handlers/views_handler_filter_boolean_operator_string.inc
index b49dde94..080ac50a 100644
--- a/drupal7/sites/all/modules/views/handlers/views_handler_filter_boolean_operator_string.inc
+++ b/drupal7/sites/all/modules/views/handlers/views_handler_filter_boolean_operator_string.inc
@@ -30,6 +30,6 @@ class views_handler_filter_boolean_operator_string extends views_handler_filter_
     else {
       $where .= "<> ''";
     }
-    $this->query->add_where($this->options['group'], $where);
+    $this->query->add_where_expression($this->options['group'], $where);
   }
 }
diff --git a/drupal7/sites/all/modules/views/handlers/views_handler_filter_fields_compare.inc b/drupal7/sites/all/modules/views/handlers/views_handler_filter_fields_compare.inc
new file mode 100644
index 00000000..fe94ce76
--- /dev/null
+++ b/drupal7/sites/all/modules/views/handlers/views_handler_filter_fields_compare.inc
@@ -0,0 +1,142 @@
+<?php
+
+/**
+ * @file
+ * Definition of views_handler_filter_fields_compare.
+ */
+
+/**
+ * A handler to filter a view using fields comparison.
+ *
+ * @ingroup views_filter_handlers
+ */
+
+class views_handler_filter_fields_compare extends views_handler_filter {
+
+  function can_expose() {
+    return FALSE;
+  }
+
+  /**
+   * Overrides views_handler_filter#option_definition().
+   */
+  function option_definition() {
+    $options = parent::option_definition();
+
+    $options['left_field'] = $options['right_field'] = array('default' => '');
+
+    return $options;
+  }
+
+  /**
+   * Provide a list of all operators.
+   */
+  function fields_operator_options() {
+    return array(
+      '<' => t('Is less than'),
+      '<=' => t('Is less than or equal to'),
+      '=' => t('Is equal to'),
+      '<>' =>  t('Is not equal to'),
+      '>=' => t('Is greater than or equal to'),
+      '>' => t('Is greater than')
+    );
+  }
+
+  /**
+   * Provide a list of available fields.
+   */
+  function field_options() {
+    $options = array();
+
+    $field_handlers = $this->view->display_handler->get_handlers('field');
+    foreach ($field_handlers as $field => $handler) {
+      if ($handler->table != 'views') {
+        $options[$field] = $handler->ui_name();
+      }
+    }
+
+    return $options;
+  }
+
+  /**
+   * Overrides views_handler_filter#options_form().
+   */
+  function options_form(&$form, &$form_state) {
+    parent::options_form($form, $form_state);
+
+    $field_options = $this->field_options();
+
+    $form['left_field'] = array(
+      '#type' => 'select',
+      '#title' => t('Left field'),
+      '#default_value' => $this->options['left_field'],
+      '#options' => $field_options,
+      '#weight' => -3,
+    );
+
+    $form['operator'] = array(
+      '#type' => 'select',
+      '#title' => t('Operator'),
+      '#default_value' => $this->options['operator'],
+      '#options' => $this->fields_operator_options(),
+      '#weight' => -2,
+    );
+
+    $form['right_field'] = array(
+      '#type' => 'select',
+      '#title' => t('Right field'),
+      '#default_value' => $this->options['right_field'],
+      '#options' => $field_options,
+      '#weight' => -1,
+    );
+
+  }
+
+  /**
+   * Overrides views_handler_filter#query().
+   *
+   * Build extra condition from existing fields (from existing joins).
+   */
+  function query() {
+    $left = $this->options['left_field'];
+    $right = $this->options['right_field'];
+
+    // Get all existing field handlers.
+    $field_handlers = $this->view->display_handler->get_handlers('field');
+
+    // Make sure the selected fields still exist.
+    if (!isset($field_handlers[$left], $field_handlers[$right])) {
+      return;
+    }
+
+    // Get the left table and field.
+    $left_handler = $field_handlers[$left];
+    $left_handler->set_relationship();
+    $left_table_alias = $this->query->ensure_table($left_handler->table, $left_handler->relationship);
+
+    // Get the left table and field.
+    $right_handler = $field_handlers[$right];
+    $right_handler->set_relationship();
+    $right_table_alias = $this->query->ensure_table($right_handler->table, $right_handler->relationship);
+
+    // Build piece of SQL.
+    $snippet =
+      $left_table_alias . '.' . $left_handler->real_field .
+      ' ' . $this->options['operator'] . ' ' .
+      $right_table_alias . '.' . $right_handler->real_field;
+
+    $this->query->add_where_expression($this->options['group'], $snippet);
+  }
+
+  /**
+   * Overrides views_handler_filter#admin_summary().
+   */
+  function admin_summary() {
+    return check_plain(
+      $this->options['left_field'] . ' ' .
+      $this->options['operator'] . ' ' .
+      $this->options['right_field']
+    );
+  }
+
+}
diff --git a/drupal7/sites/all/modules/views/includes/admin.inc b/drupal7/sites/all/modules/views/includes/admin.inc
index 160a61a1..1f247bd0 100644
--- a/drupal7/sites/all/modules/views/includes/admin.inc
+++ b/drupal7/sites/all/modules/views/includes/admin.inc
@@ -408,7 +408,7 @@ function views_ui_add_form($form, &$form_state) {
  */
 function views_element_validate_integer($element, &$form_state) {
   $value = $element['#value'];
-  if ($value !== '' && (!is_numeric($value) || intval($value) != $value)) {
+  if ($value !== '' && (!is_numeric($value) || intval($value) != $value || abs($value) != $value)) {
     form_error($element, t('%name must be a positive integer.', array('%name' => $element['#title'])));
   }
 }
